"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ListingFilterCore_1 = require("./ListingFilterCore");
const react_1 = __importDefault(require("react"));
const material_1 = require("@mui/material");
function ListingFilterDisplay({ operationMap, valueMap, labelMap, }) {
    const { removeFilter, filterStates } = (0, ListingFilterCore_1.useListingFilterProvider)();
    const hasFilters = Object.keys(filterStates).filter((f) => Boolean(filterStates[f])).length >
        0;
    return (react_1.default.createElement(material_1.Box, { sx: { position: "relative", py: hasFilters ? 1 : 0 } },
        react_1.default.createElement(material_1.Stack, { sx: { overflowX: "auto", w: "full" } },
            react_1.default.createElement(material_1.Stack, { direction: "row", gap: 1 }, Object.keys(filterStates)
                .filter((f) => Boolean(filterStates[f]))
                .map((f, i) => {
                var _a, _b;
                return (react_1.default.createElement(material_1.Chip, { sx: { borderRadius: 1, fontSize: "13px" }, onDelete: () => removeFilter(f), key: i, label: generateStatements((_a = filterStates[f]) === null || _a === void 0 ? void 0 : _a.queryFunc((_b = filterStates[f]) === null || _b === void 0 ? void 0 : _b.value), operationMap || {}, labelMap || {}, valueMap || {}) }));
            })))));
}
exports.default = ListingFilterDisplay;
function generateStatements(filters, operationMap, keyMap, valueMap) {
    const keys = Object.keys(filters);
    const isOr = (keys === null || keys === void 0 ? void 0 : keys.length) === 1 && keys[0] === "or";
    const isAnd = (keys === null || keys === void 0 ? void 0 : keys.length) === 1 && keys[0] === "and";
    if (isOr) {
        const values = filters === null || filters === void 0 ? void 0 : filters.or;
        return values === null || values === void 0 ? void 0 : values.reduce((p, c, i) => {
            return `${p} ${i === 0 ? "" : " or "} ${generateStatements(c, operationMap, keyMap, valueMap)}`;
        }, "");
    }
    else if (isAnd) {
        const values = filters === null || filters === void 0 ? void 0 : filters.and;
        return values === null || values === void 0 ? void 0 : values.reduce((p, c, i) => `${p} ${i === 0 ? "" : " and "} ${generateStatements(c, operationMap, keyMap, valueMap)}`, "");
    }
    return handleRootFilters(filters, operationMap, keyMap, valueMap);
}
function handleRootFilters(rootFilter, operationMap, keyMap, valueMap) {
    const keys = Object === null || Object === void 0 ? void 0 : Object.keys(rootFilter);
    if ((keys === null || keys === void 0 ? void 0 : keys.length) <= 0)
        return "";
    const key = keys[0];
    const operations = Object.keys(rootFilter[key]);
    if ((operations === null || operations === void 0 ? void 0 : operations.length) <= 0)
        return "";
    const operation = operations[0];
    const value = rootFilter[key][operation] || "";
    return keys === null || keys === void 0 ? void 0 : keys.reduce((p) => `${p} ${keyMap[key] || key} ${operationMap[operation] || operation} ${valueMap[key]
        ? valueMap[key](value)
        : value === null || value === void 0 ? void 0 : value.replaceAll("*", "")}`, "");
}
//# sourceMappingURL=ListingFilterDisplay.js.map